(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/WebsocketUtil.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'e0c5dTi4sNKILhtDWJWxKIz', 'WebsocketUtil', __filename);
// Script/WebsocketUtil.ts

Object.defineProperty(exports, "__esModule", { value: true });
var ConstUtil_1 = require("./ConstUtil");
// Learn TypeScript:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html
// import io  from "../libs/socket/socket.io"
var WebsocketUtil = /** @class */ (function () {
    function WebsocketUtil() {
        //网络延时 ms
        this.delayMS = 0;
        this.sio = null;
        this.connected = false;
        this.isPinging = false;
        this.lastRecieveTime = 0;
        this.lastSendTime = 0;
    }
    WebsocketUtil.prototype.WebsocketUtil = function () { };
    /**
     * 初始化
    */
    WebsocketUtil.prototype.init = function (token, userId, cb) {
        var _this = this;
        this.sio = new WebSocket(ConstUtil_1.default.Instance.MESSAGE_URL + "/" + token, "default-protocol");
        this.sio.onopen = function (event) {
            console.log('connect');
            _this.connected = true;
            _this.lastRecieveTime = Date.now();
            _this.delayMS = _this.lastRecieveTime - _this.lastSendTime;
            _this.startHearbeat(userId, cb);
        };
        this.sio.onclose = function (event) {
            console.log("disconnect");
            _this.connected = false;
        };
    };
    /**
     * 获取客户端实体
    */
    WebsocketUtil.prototype.getClient = function () {
        return this.sio;
    };
    /**
     * 开启心跳包
    */
    WebsocketUtil.prototype.startHearbeat = function (userId, cb) {
        var _this = this;
        if (!this.isPinging) {
            this.isPinging = true;
            setInterval(function () {
                if (_this.sio) {
                    _this.ping(userId, cb);
                }
            }, 2000);
            setInterval(function () {
                if (_this.sio) {
                    if (Date.now() - _this.lastRecieveTime > 10000) {
                        _this.close();
                    }
                }
            }, 500);
        }
    };
    /**
     * ping
    */
    WebsocketUtil.prototype.ping = function (userId, cb) {
        if (this.sio) {
            this.lastSendTime = Date.now();
            this.emit("MESSAGE_TYPE_HEARTBEAT", userId, cb);
        }
    };
    /**
     * 关闭
    */
    WebsocketUtil.prototype.close = function () {
        console.log('close');
        this.delayMS = null;
        if (this.sio && this.connected) {
            this.connected = false;
            this.sio.close();
        }
        this.sio = null;
    };
    /**
     * 绑定事件
     * @param event
     * @param cb
     */
    WebsocketUtil.prototype.onmessage = function (cb) {
        var _this = this;
        this.sio.onmessage = function (payload) {
            _this.lastRecieveTime = Date.now();
            // console.log("数据: " + payload.data);
            // if (payload.data instanceof Object) {
            var obj = JSON.parse(payload.data);
            cb(obj.code, obj.commandType, obj.payload);
        };
    };
    /**
     * 错误监听
     * @param cb
     */
    WebsocketUtil.prototype.onerror = function (cb) {
        this.sio.onerror = function (event) {
            cb(404, "发送消息错误");
        };
    };
    /**
     * 发送消息
     * @param event
     * @param data
     */
    WebsocketUtil.prototype.emit = function (event, data, cb) {
        if (this.sio != null && (this.sio.readyState == this.sio.OPEN)) {
            var messageBean = {
                commandType: event,
                code: 200,
                payload: data
            };
            this.sio.send(JSON.stringify(messageBean));
        }
        else {
            cb(404, "连接被关闭，请退出重新进入");
        }
    };
    WebsocketUtil.Instance = new WebsocketUtil();
    return WebsocketUtil;
}());
exports.default = WebsocketUtil;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=WebsocketUtil.js.map
        