(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/business.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, '73a0b7yKA5Jn4w19QPt6df7', 'business', __filename);
// Script/business.ts

Object.defineProperty(exports, "__esModule", { value: true });
var WebsocketUtil_1 = require("./WebsocketUtil");
var ConstUtil_1 = require("./ConstUtil");
var HttpUtil_1 = require("./HttpUtil");
var DataCache_1 = require("./DataCache");
var Business = /** @class */ (function () {
    function Business() {
    }
    Business.prototype.Business = function () { };
    Business.prototype.onMessages = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                cb(type, code, data);
            }
            else {
                // console.log("监听消息失败")
            }
        });
    };
    /**
     * 监听连接状态
     * @param cb
     */
    Business.prototype.onConnected = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_CONNECT) {
                    cb(200, data);
                }
            }
            else {
                cb(500, "连接出错");
            }
        });
    };
    Business.prototype.onFastJoinResultMessage = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_FAST_JOIN) {
                    cb(200, data);
                }
            }
            else {
                cb(500, "连接出错");
            }
        });
    };
    /**
    * 监听创建房间结果的消息
    */
    Business.prototype.onCreateRoomResultMessage = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (Business.MESSAGE_TYPE_CREATE_ROOM_RESULT == type)
                    cb(200, data);
            }
            else {
                console.log("创建房间失败");
            }
        });
    };
    /**
   * 监听心跳消息
   */
    Business.prototype.onHearBeat = function () {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_HEARTBEAT) {
                    console.log("心跳正常");
                }
            }
        });
    };
    /**
     * 监听加入房间的消息
     */
    Business.prototype.onJoinRoomResultMessage = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_JOIN_ROOM_RESULT) {
                    cb(200, data);
                }
            }
        });
    };
    /**
     * 监听先手消息
     */
    Business.prototype.onFistHandPoint = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_FIRST_HAND_RESULT)
                    cb(200, data);
            }
        });
    };
    /**
   * 监听游戏结果
   */
    // onGameResult() {
    //     NetUtil.Instance.onmessage<GameResultResp>(Business.MESSAGE_TYPE_GAME_RESULT, function (code, data: GameResultResp) {
    //     })
    // }
    /**
  * 监听抽牌结果
  */
    // onDrawResult() {
    //     NetUtil.Instance.onmessage<DrawResultResp>(Business.MESSAGE_TYPE_DRAW_RESULT, function (code, data: DrawResultResp) {
    //     })
    // }
    /**
   * 监听发牌结果
   */
    Business.prototype.onDealResult = function (cb) {
        WebsocketUtil_1.default.Instance.onmessage(function (code, type, data) {
            if (code == 200) {
                if (type == Business.MESSAGE_TYPE_DEAL_RESULT)
                    cb(200, data);
            }
        });
    };
    /**
    * 监听亮牌结果
    */
    // onShowCards() {
    //     NetUtil.Instance.onmessage<ShowCardResp>(Business.MESSAGE_TYPE_SHOW_CARD_RESULT, function (code, data: ShowCardResp) {
    //     })
    // }
    /**
  * 监听游戏点数结果
  */
    // onGamePoint() {
    //     NetUtil.Instance.onmessage<GamePointResp>(Business.MESSAGE_TYPE_GAME_POINT, function (code, data: GamePointResp) {
    //     })
    // }
    /**
    * 监听离开游戏的消息
    */
    // onLeaveGame() {
    //     NetUtil.Instance.onmessage<LeaveGameResp>(Business.MESSAGE_TYPE_LEAVE_GAME, function (code, data: LeaveGameResp) {
    //     })
    // }
    /**
   * 监听被动卡牌结果消息
   */
    // onPassivityCard() {
    //     NetUtil.Instance.onmessage<PassiveCardResp>(Business.MESSAGE_TYPE_CARD_PASSIVE_RESULT, function (code, data: PassiveCardResp) {
    //     })
    // }
    /**
     * 监听主动卡牌消息
     */
    // onActiveCards() {
    //     NetUtil.Instance.onmessage<ActiveCardResp>(Business.MESSAGE_TYPE_ACTIVE_CARD_RESULT, function (code, data: ActiveCardResp) {
    //     })
    // }
    /**
     * 初始化连接
     * @param token
     * @param cb
     */
    Business.prototype.initConnect = function (token, userId, cb) {
        WebsocketUtil_1.default.Instance.init(token, userId, cb);
    };
    /**
   * 发送加入房间的消息
   */
    Business.prototype.sendFastJoin = function (userId, portrait, nickName) {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_FAST_JOIN, {
            "userId": userId,
            "portrait": portrait,
            "nickName": nickName
        }, function (code, data) {
            if (code == 404) {
                console.log(data);
            }
        });
    };
    /**
     * 发送创建房间的消息
     */
    Business.prototype.sendCreateRoomMessage = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_CREATE_ROOM, {
            "name": "",
            "userId": "" //用户编号
        });
    };
    /**
     * 发送加入房间的消息
     */
    Business.prototype.sendJoinRoomMessage = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_JOIN_ROOM, {
            "roomId": "",
            "userId": "",
            "portrait": "",
            "nickName": ""
        });
    };
    /**
     * 发送先手点数
     */
    Business.prototype.sendFistHandPoint = function (point, userId, roomId) {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_FIRST_HAND, {
            "point": point,
            "userId": userId,
            "roomId": roomId
        });
    };
    /**
     * 发送卡牌命令消息
     */
    Business.prototype.sendDealCommand = function (roomId, userId) {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_DEAL_COMMAND, {
            "roomId": roomId,
            "userId": userId
        });
    };
    /**
     * 发送抽中卡牌结果
     */
    Business.prototype.sendDrawResult = function (index, cardId, userId, roomId) {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_DRAW, {
            "index": index,
            "cardId": cardId,
            "roomId": roomId,
            "userId": userId
        });
    };
    /**
     * 发送被动卡牌消息
     */
    Business.prototype.sendPassivityCard = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_CARD_PASSIVE, {
            "cardId": "",
            "roomId": "",
            "userId": ""
        });
    };
    /**
     * 亮牌
     */
    Business.prototype.sendShowCards = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_SHOW_CARD, {
            "roomId": "",
            "userId": "",
            "cardIds": []
        });
    };
    /**
     * 发送主动卡牌
     */
    Business.prototype.sendActiveCards = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_ACTIVE_CARD, {
            "userId": "",
            "roomId": "",
            "cardIds": []
        });
    };
    /**
     * 发送离开游戏的消息
     */
    Business.prototype.sendLeaveGame = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_LEAVE_GAME, {
            "roomId": "",
            "userId": ""
        });
    };
    /**
     * 发送决定胜负的游戏点数
     */
    Business.prototype.sendGamePoint = function () {
        WebsocketUtil_1.default.Instance.emit(Business.MESSAGE_TYPE_GAME_POINT, {
            "point": "",
            "userId": "",
            "roomId": ""
        });
    };
    /**
     *
     * @param cardName 根据卡牌名称获取卡牌的链接地址
     */
    Business.prototype.getPictureUrlByName = function (cardName) {
        return "http://xk.linqmind.com/" + cardName + ".jpg";
    };
    /**
     * 批量获取卡片的图片地址
     * @param cardNames
     */
    Business.prototype.getPictureUrlsByNames = function (cardNames) {
        return cardNames.map(function (cardName) {
            return "http://xk.linqmind.com/" + cardName + ".jpg";
        });
    };
    /**
     * 判断用户是否是先手
     *
     * @param userDetail
     * @param firstHandle
     */
    Business.prototype.getIsFirstHandle = function (userDetail, firstHandle) {
        return firstHandle.playerFirstHandInfos.filter(function (element) {
            return element.userId === userDetail.userId;
        }).map(function (element) {
            return element.firstHand;
        })[0];
    };
    /**
     * 获取被动卡牌
     */
    Business.prototype.getPassiveCards = function () {
        return new Promise(function (resolve, reject) {
            HttpUtil_1.default.Instance.httpGets(ConstUtil_1.default.Instance.PASSIVE_CARD, function (code, response) {
                if (code == 401) {
                    reject("服务器访问拒绝");
                }
                else {
                    console.log(response);
                    var obj = JSON.parse(response);
                    if (obj.status == 0) {
                        //将被动动卡牌缓存在本地
                        DataCache_1.default
                            .Instance
                            .saveObj(obj.data, ConstUtil_1.default.Instance.KEY_DATA_PASSIVE_CARD);
                        resolve(obj.data);
                    }
                    else {
                        reject("获取被动卡失败: " + obj.message);
                    }
                }
            });
        });
    };
    /**
     * 获取主动卡牌
     */
    Business.prototype.getActivieCards = function () {
        return new Promise(function (resolve, reject) {
            HttpUtil_1.default.Instance.httpGets(ConstUtil_1.default.Instance.ACTIVE_CARD, function (code, response) {
                if (code == 401) {
                    reject("服务器访问拒绝");
                }
                else {
                    console.log(response);
                    var obj = JSON.parse(response);
                    if (obj.status == 0) {
                        //将主动卡牌缓存在本地
                        DataCache_1.default
                            .Instance
                            .saveObj(obj.data, ConstUtil_1.default.Instance.KEY_DATA_ACTIVE_CARD);
                        resolve(obj.data);
                    }
                    else {
                        reject("获取被动卡失败: " + obj.message);
                    }
                }
            });
        });
    };
    /**
     * 用户登录
     */
    Business.prototype.login = function (phoneNo, msgCode) {
        return new Promise(function (resolve, reject) {
            HttpUtil_1.default.Instance.httpPost(ConstUtil_1.default.Instance.LOGIN, 
            // 'https://api.linqmind.com/api/auth/login',
            {
                "accessCode": "string",
                "accessToken": "string",
                "channelId": "string",
                "deviceToken": "string",
                "loginType": "string",
                "mobilePhone": phoneNo,
                "msgCode": "string",
                "osType": "string",
                "password": msgCode
            }, function (code, response) {
                if (code == 401) {
                    reject("服务器访问拒绝");
                }
                else {
                    var obj = JSON.parse(response);
                    if (obj.status == 0) {
                        console.log("保存数据前:", obj.data.userId);
                        // cc.sys.localStorage.setItem(ConstUtil.Instance.KEY_DATA_USER_LOGIN, JSON.stringify(obj.data))
                        DataCache_1.default.Instance.saveObj(obj.data, ConstUtil_1.default.Instance.KEY_DATA_USER_LOGIN);
                        resolve(obj.data);
                    }
                    else {
                        reject("用户名或密码错误!");
                    }
                }
            });
        });
    };
    /**
     * 获取用户信息
     */
    Business.prototype.getUserDetail = function (userId) {
        return new Promise(function (resolve, reject) {
            HttpUtil_1.default.Instance.httpGets(ConstUtil_1.default.Instance.GET_USER_DETAIL + '/' + userId, 
            // 'https://api.linqmind.com/api/users',
            function (code, response) {
                if (code == 401) {
                    reject("服务器访问拒绝");
                }
                else {
                    var obj = JSON.parse(response);
                    if (obj.status == 0) {
                        //保存用户详细信息
                        cc.sys.localStorage.setItem(ConstUtil_1.default.Instance.KEY_DATA_USER_DETAIL, JSON.stringify(obj.data));
                        // DataCache.Instance.saveObj(obj.data, ConstUtil.Instance.KEY_DATA_USER_DETAIL)
                        resolve(true);
                    }
                    else {
                        reject("获取用户信息失败!");
                    }
                }
            });
        });
    };
    /**
     * 判断用户是否登录
     */
    Business.prototype.getHasLogin = function () {
        return new Promise(function (resolve, reject) {
            if (DataCache_1.default.Instance.getObj(ConstUtil_1.default.Instance.KEY_DATA_USER_DETAIL)) {
                resolve(true);
            }
            else {
                reject("用户未登录");
            }
        });
    };
    /**
     * 发送短信验证码
     * @param phoneNo
     */
    Business.prototype.sendMessageCode = function (phoneNo) {
        return new Promise(function (resolve, reject) {
            HttpUtil_1.default.Instance.httpPost(ConstUtil_1.default.Instance.SEND_MSG, {
                "phoneNum": phoneNo,
                "deviceId": "ffdasfdsa",
                "status": "0"
            }, function (code, response) {
                if (code == 401) {
                    reject("服务器访问拒绝");
                }
                else {
                    console.log(response);
                    var obj = JSON.parse(response);
                    if (obj.status == 0 && obj.data) {
                        resolve(true);
                    }
                    else {
                        reject("短信发送失败");
                    }
                }
            });
        });
    };
    Business.Instance = new Business();
    //监听创建房间结果消息
    Business.MESSAGE_TYPE_CREATE_ROOM_RESULT = 'MESSAGE_TYPE_CREATE_ROOM_RESULT';
    //创建房间结果消息
    Business.MESSAGE_TYPE_CREATE_ROOM = 'MESSAGE_TYPE_CREATE_ROOM';
    //加入房间消息
    Business.MESSAGE_TYPE_JOIN_ROOM = 'MESSAGE_TYPE_JOIN_ROOM';
    //加入房间结果消息
    Business.MESSAGE_TYPE_JOIN_ROOM_RESULT = 'MESSAGE_TYPE_JOIN_ROOM_RESULT';
    //确定先手消息
    Business.MESSAGE_TYPE_FIRST_HAND = 'MESSAGE_TYPE_FIRST_HAND';
    //确定先手结果消息
    Business.MESSAGE_TYPE_FIRST_HAND_RESULT = 'MESSAGE_TYPE_FIRST_HAND_RESULT';
    //开始发牌指令消息
    Business.MESSAGE_TYPE_DEAL_COMMAND = 'MESSAGE_TYPE_DEAL_COMMAND';
    //发牌结果消息
    Business.MESSAGE_TYPE_DEAL_RESULT = 'MESSAGE_TYPE_DEAL_RESULT';
    //抽牌消息
    Business.MESSAGE_TYPE_DRAW = 'MESSAGE_TYPE_DRAW';
    //抽牌结果消息
    Business.MESSAGE_TYPE_DRAW_RESULT = 'MESSAGE_TYPE_DRAW_RESULT';
    //被动卡牌消息
    Business.MESSAGE_TYPE_CARD_PASSIVE = 'MESSAGE_TYPE_CARD_PASSIVE';
    //被动卡牌结果消息
    Business.MESSAGE_TYPE_CARD_PASSIVE_RESULT = 'MESSAGE_TYPE_CARD_PASSIVE_RESULT';
    //本局抽卡结束
    Business.MESSAGE_TYPE_END_SIGNAL = 'MESSAGE_TYPE_END_SIGNAL';
    //当回合抽卡结束
    Business.MESSAGE_TYPE_ROUND_END_SIGNAL = 'MESSAGE_TYPE_ROUND_END_SIGNAL';
    //出牌消息
    Business.MESSAGE_TYPE_SHOW_CARD = 'MESSAGE_TYPE_SHOW_CARD';
    //出牌结果消息
    Business.MESSAGE_TYPE_SHOW_CARD_RESULT = 'MESSAGE_TYPE_SHOW_CARD_RESULT';
    //主动卡牌消息
    Business.MESSAGE_TYPE_ACTIVE_CARD = 'MESSAGE_TYPE_ACTIVE_CARD';
    //主动卡牌结果消息
    Business.MESSAGE_TYPE_ACTIVE_CARD_RESULT = 'MESSAGE_TYPE_ACTIVE_CARD_RESULT';
    //游戏结果消息
    Business.MESSAGE_TYPE_GAME_RESULT = 'MESSAGE_TYPE_GAME_RESULT';
    //游戏胜负点数
    Business.MESSAGE_TYPE_GAME_POINT = 'MESSAGE_TYPE_GAME_POINT';
    //离开游戏
    Business.MESSAGE_TYPE_LEAVE_GAME = 'MESSAGE_TYPE_LEAVE_GAME';
    //心跳消息
    Business.MESSAGE_TYPE_HEARTBEAT = 'MESSAGE_TYPE_HEARTBEAT';
    //快速开始游戏
    Business.MESSAGE_TYPE_FAST_JOIN = 'MESSAGE_TYPE_FAST_JOIN';
    //连接
    Business.MESSAGE_TYPE_CONNECT = 'TYPE_CONNECT';
    return Business;
}());
exports.default = Business;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=business.js.map
        